import java.awt.event.*;
import javax.swing.*;
import org.w3c.dom.*;

public class DrchkTab extends ToolTab implements ItemListener {
	public static String[] lines = {
			"This KMT tool is designed to detect rootkits which use the",
			"x86 Debug Registers, the canonical example being AUTHOR's DR.c rootkit.",
			"This tool will detect whether or not the INT 1 handler has been",
			"patched with an evil do_debug call." };
	JCheckBox mFlagCheckBox = null;

	JCheckBox sFlagCheckBox = null;

	public DrchkTab() {
		super("dr_chk", lines);

		this.sFlagCheckBox = new JCheckBox(
				"Use configured system.map file instead of the default /proc/kallsyms");
		sFlagCheckBox.setSelected(false);
		sFlagCheckBox.setEnabled(false);
		sFlagCheckBox.addItemListener(this);

		this.mFlagCheckBox = new JCheckBox(
				"Use /dev/kmt_mem instead of /dev/kmem");
		mFlagCheckBox.setSelected(false);
		mFlagCheckBox.setEnabled(false);
		mFlagCheckBox.addItemListener(this);

		super.ltabCent.add(sFlagCheckBox);
		super.ltabCent.add(mFlagCheckBox);

		super.finishGui();
	}

	public void buildAndSetArgs() {

		String xpathStr = "/root_element/tool/exec_info[@name=\"dr_chk\"]/@opts";
		Node node = XTree.findNode(xpathStr, jkmt.xmlEditorPanel.xTree.doc);
		if (node == null)
			return;

		String args = " "; // throws out whatever was there and absolutely sets
		// it. for now u can still run kmtd with a modified
		// special args as long as u never mess wit the tab.
		// TODO: perhaps getTextContent() and modify it
		// instead of absolutely setting.

		if (mFlagCheckBox.isSelected()) {
			args += "-M";
		}

		if (sFlagCheckBox.isSelected()) {
			String sysMap = (String) jkmt.optionsTab.systemMapList
					.getSelectedItem(); /*
										 * could alternatively have gotten it
										 * from xml, but this is faster
										 */
			if (sysMap == null)
				return;
			args += " -S " + sysMap;
		}

		XTree.updateNodeContent(node, xpathStr, args); /*
														 * update command line
														 * opts
														 */

		super.refreshCmdArgsLabel();// refresh this tabs jlabel of cmds, TODO:
		// make another method so it doesnt have to
		// get the xml as this one does .

	}

	@Override
	public void disableAll() {
		super.disableAll();
		sFlagCheckBox.setEnabled(false);
		sFlagCheckBox.setSelected(false);

		mFlagCheckBox.setEnabled(false);
		mFlagCheckBox.setSelected(false);

	}

	// this is optional in tooltab subclasses, if not present supers (an
	// instance of ToolTab) will be called directly.
	@Override
	public void enableAtConnect() {
		super.enableAtConnect(); // overrides super's

		/* populate fields with the values from DOM */
		Node node = XTree.findNode("/root_element/tool/exec_info[@name=\""
				+ toolName + "\"]/@opts", jkmt.xmlEditorPanel.xTree.doc);
		// if(node == null)
		// error
		boolean sF = false, mF = false;
		String curVal = node.getTextContent();

		if (curVal.contains("-S "))
			sF = true;
		if (curVal.contains("-M"))
			mF = true;

		sFlagCheckBox.setSelected(sF);
		mFlagCheckBox.setSelected(mF);

		sFlagCheckBox.setEnabled(true);
		mFlagCheckBox.setEnabled(true);

	}

	// for the checkbox
	// override's supers
	@Override
	public void itemStateChanged(ItemEvent e) {
		super.itemStateChanged(e); /*
									 * this.itemStateChange was intercepting the
									 * ones for super'sc checkbox. this is the
									 * fix
									 */
		if (e.getSource() != this.sFlagCheckBox
				&& e.getSource() != this.mFlagCheckBox)
			return;

		buildAndSetArgs();
	}

}
