/* Copyright (c) 2009, Sean A.O. Harney */

//~--- JDK imports ------------------------------------------------------------
import java.awt.*;

import java.io.*;

import javax.swing.*;

//similar to "tail -f" on an InputStream
//contents unformatted in scrollpane
//TODO: files with binary data.???.
//usuallly used with DataInputStream
public class IStreamScrollPanel extends JPanel {
	private InputStream is;
	private int printCount = -1;
	private JScrollPane scrollPane;
	private JTextArea textArea;

	public IStreamScrollPanel(InputStream ins, boolean start) {
		this.is = new BufferedInputStream(ins);
		setPreferredSize(new Dimension(700, 400)); // needed?
		setBackground(Color.GRAY);
		textArea = new JTextArea();
		textArea.setEditable(false);
		scrollPane = new JScrollPane(textArea,
				ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);

		// JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		scrollPane.setPreferredSize(new Dimension(650, 385)); // slighly

		// smaller than
		// the
		// ConsolePanel.
		add(scrollPane);

		if (start) {
			startLoop(); // call it from the consructor.//TODO:untested
		}
	}

	// method for outputing messages to console panel
	public void println(String s) {

		// textArea.append(++printCount + ":\t" + s + "\n");
		textArea.append(s);

		// scrollPane.getVerticalScrollBar().setValue(
		// scrollPane.getVerticalScrollBar().getMaximum()); // auto-scroll,
		// doesn't always work.
		// the
		// scroll
		// pane to
		// the end
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				scrollPane.getVerticalScrollBar().setValue(
						scrollPane.getVerticalScrollBar().getMaximum());
			}
		});
	}

	// starts a new child thread with an infinite loop to read and print the
	// file.
	public void startLoop() {

		// inline declaration
		new Thread(new Runnable() {
			public void run() {
				try {

					// child thread
					// DataInputStream dis = new DataInputStream(new
					// (fileFileInputStream));
					while (true) {
						int n = is.available();

						if (n > 0) // has unread data
						{
							byte[] buf = new byte[n]; // dynamic array

							is.read(buf); // read at most buf.length

							// using this String constructor should be binary
							// safe.
							println(new String(buf));
						}

						// sleep 1 second
						Thread.sleep(1000);
					}
				} catch (Exception e) {
					e.printStackTrace();

					return; // throw exception (to parent??)
				}
			}
		}).start();
	}
}

// ~ Formatted by Jindent --- http://www.jindent.com
