//~--- JDK imports ------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;

import org.w3c.dom.*;

public class OptionsTab extends JPanel implements ActionListener, ItemListener {
	public JList emailList = null;
	Jkmt jkmt = Jkmt.getInstance();
	public JComboBox kernelImageList = null;
	public JTextField mailUtil = null;

	JTabbedPane optsTabPane;
	public JCheckBox sendAlertsCB = null;
	public JComboBox systemMapList = null;
	JTabbedPane tabPane;

	UpdateServerPanel usp = null;
	public JPasswordField zipPassWord = null;

	public OptionsTab() {
		super();
		setLayout(new BorderLayout());
		tabPane = new JTabbedPane();
		optsTabPane = new JTabbedPane();

		JPanel ltab = new JPanel();
		JPanel rtab = new JPanel();
		String[] systemMapStrings = { "---------------------------------" };
		String[] kernelImageStrings = { "---------------------------------" };

		Dimension lsize = new Dimension(475, 35);
		this.systemMapList = new JComboBox(systemMapStrings);
		systemMapList.setActionCommand("smlist");
		systemMapList.setEnabled(false); // enabled upon connect
		systemMapList.addActionListener(this);
		systemMapList.setPreferredSize(lsize);
		systemMapList.setMinimumSize(lsize);
		systemMapList.setMaximumSize(lsize);

		this.kernelImageList = new JComboBox(kernelImageStrings);
		kernelImageList.setActionCommand("kilist");
		kernelImageList.setEnabled(false); // enabled upon connect
		kernelImageList.addActionListener(this);
		kernelImageList.setPreferredSize(lsize);
		kernelImageList.setMinimumSize(lsize);
		kernelImageList.setMaximumSize(lsize);

		ltab.setLayout(new FlowLayout(FlowLayout.LEADING));// align left
		this.usp = new UpdateServerPanel();
		add(usp, BorderLayout.NORTH);

		JPanel general = new JPanel();
		general.setLayout(new BoxLayout(general, BoxLayout.Y_AXIS));

		JPanel p1 = new JPanel();
		p1.setLayout(new BorderLayout());
		JPanel tmpA = new JPanel();
		tmpA
				.add(new JLabel(
						"<html>"
								+ "<p><font size=\"4\">System.map file:&nbsp;&nbsp;&nbsp;&nbsp;</font></p>"
								+ "</html>"));
		p1.add(tmpA, BorderLayout.WEST);
		JPanel tmp0 = new JPanel();
		tmp0.add(systemMapList);
		p1.add(tmp0, BorderLayout.CENTER);
		general.add(p1);
		general.add(new JSeparator());

		JPanel p2 = new JPanel();
		p2.setLayout(new BorderLayout());
		JPanel tmpB = new JPanel();
		tmpB
				.add(new JLabel(
						"<html>"
								+ "<p><font size=\"4\">Kernel image file:&nbsp;&nbsp;</font></p>"
								+ "</html>"));
		p2.add(tmpB, BorderLayout.WEST);
		JPanel tmp1 = new JPanel();
		tmp1.add(kernelImageList);
		p2.add(tmp1, BorderLayout.CENTER);
		general.add(p2);
		general.add(new JSeparator());

		JPanel alerts = new JPanel();
		alerts.setLayout(new BoxLayout(alerts, BoxLayout.Y_AXIS));
		JPanel p3 = new JPanel();
		p3.setLayout(new BorderLayout());
		p3
				.add(
						new JLabel(
								"<html>"
										+ "<p><font size=\"4\">Send Email Alerts:&nbsp;&nbsp;</font></p>"
										+ "</html>"), BorderLayout.WEST);
		this.sendAlertsCB = new JCheckBox("Send Email Alerts");
		sendAlertsCB.setSelected(false);
		sendAlertsCB.setEnabled(false);

		p3.add(sendAlertsCB, BorderLayout.CENTER);
		alerts.add(p3);
		alerts.add(new JSeparator());

		JPanel p4 = new JPanel();
		p4.setLayout(new BorderLayout());
		p4
				.add(
						new JLabel(
								"<html>"
										+ "<p><font size=\"4\">Zip File Password:&nbsp;&nbsp;</font></p>"
										+ "</html>"), BorderLayout.WEST);

		this.zipPassWord = new JPasswordField(15);
		zipPassWord.setEnabled(false);
		p4.add(zipPassWord, BorderLayout.CENTER);
		alerts.add(p4);
		alerts.add(new JSeparator());

		JPanel p5 = new JPanel();
		p5.setLayout(new BorderLayout());
		p5.add(new JLabel("<html>"
				+ "<p><font size=\"4\">Mail Command:&nbsp;&nbsp;</font></p>"
				+ "</html>"), BorderLayout.WEST);

		this.mailUtil = new JTextField(15);
		mailUtil.setEnabled(false);
		p5.add(mailUtil, BorderLayout.CENTER);
		alerts.add(p5);
		alerts.add(new JSeparator());

		JPanel p6 = new JPanel();
		p6.setLayout(new BorderLayout());
		p6.add(new JLabel("<html>"
				+ "<p><font size=\"4\">Email Addresses:&nbsp;&nbsp;</font></p>"
				+ "</html>"), BorderLayout.WEST);

		this.emailList = new JList();
		emailList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		// emailList.setSelectedIndex(0); // the default is first in
		emailList.setEnabled(false);
		/*
		 * ListSelectionModel lsm = emailList.getSelectionModel();
		 * lsm.addListSelectionListener(this);
		 */

		JScrollPane scrollPane = new JScrollPane(emailList,
				ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
				ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);

		Dimension size = new Dimension(300, (int) scrollPane.getPreferredSize()
				.getHeight());
		scrollPane.setPreferredSize(size);
		scrollPane.setMinimumSize(size);
		scrollPane.setMaximumSize(size);
		JPanel tmpp = new JPanel();/*
									 * needed to keep scrollPane from being
									 * stretched
									 */
		tmpp.add(scrollPane);

		p6.add(tmpp, BorderLayout.CENTER);
		alerts.add(p6);
		alerts.add(new JSeparator());

		optsTabPane.add("General", general);
		optsTabPane.add("Email Alerts", alerts);
		ltab.add(optsTabPane);
		rtab.add(jkmt.xmlEditorPanel);
		tabPane.add("Options", ltab);
		tabPane.add("XML Tree", rtab);
		add(tabPane);
	}

	// for the 2 JComboBox
	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();

		if (!cmd.equals("smlist") && !cmd.equals("kilist"))
			return;

		try {
			JComboBox cb = (JComboBox) e.getSource();

			String newVal = (String) cb.getSelectedItem();
			if (newVal == null)
				return;

			String xpathStr = null;

			if (cmd.equals("smlist")) {
				xpathStr = "/root_element/system_map";

			} else if (cmd.equals("kilist")) {
				xpathStr = "/root_element/kernel_image";
			}

			Node node = XTree.findNode(xpathStr, jkmt.xmlEditorPanel.xTree.doc);
			if (node == null)
				return;
			String curVal = node.getTextContent();

			XTree.updateNodeContent(node, xpathStr, newVal);

			/* update command line options */
			if (cmd.equals("smlist")) {
				xpathStr = "/root_element/tool/exec_info[@name=\"dps\"]/@opts";
				// using newVal calculated previously above
			} else if (cmd.equals("kilist")) {
				xpathStr = "/root_element/tool/exec_info[@name=\"kmemstat\"]/@opts";
				if (newVal != null)
					newVal = "-k " + newVal + " -a";
			}
			node = XTree.findNode(xpathStr, jkmt.xmlEditorPanel.xTree.doc);
			if (node == null)
				return;
			XTree.updateNodeContent(node, xpathStr, newVal);

			if (cmd.equals("smlist")) {
				jkmt.dpsTab.refreshCmdArgsLabel();
				jkmt.ksymstatTab.buildAndSetArgs();
				jkmt.drchkTab.buildAndSetArgs(); // calls refreshCmdArgsLabel
			} else if (cmd.equals("kilist")) {
				jkmt.kmemstatTab.refreshCmdArgsLabel();
			}

		} catch (Exception ex) {
			ex.printStackTrace();
		}

	}

	public void disableAll() {
		this.usp.disableAll();
		this.systemMapList.setEnabled(false);
		this.kernelImageList.setEnabled(false);
		this.sendAlertsCB.setEnabled(false);
	}

	public void enableAtConnect() {

		// NOTE: kimage,sysmap get updated after connecting (after find cmds
		// responses received), this func is called immediately after being
		// connected/authenticated
		this.usp.enableAtConnect();
		this.systemMapList.setEnabled(true);
		this.kernelImageList.setEnabled(true);

		/* populate fields with the values from DOM */
		Node node = XTree.findNode("/root_element/send_alerts",
				jkmt.xmlEditorPanel.xTree.doc);
		// if(node == null) error
		String curVal = node.getTextContent();
		boolean sendAlerts = true;
		if ("0".equals(curVal))/* anything but 0 its on */
			sendAlerts = false;
		this.sendAlertsCB.setSelected(sendAlerts);
		sendAlertsCB.setEnabled(true);
		sendAlertsCB.addItemListener(this);// only add here

		node = XTree.findNode("/root_element/zip_passwd",
				jkmt.xmlEditorPanel.xTree.doc);
		// if(node == null) error
		curVal = node.getTextContent();

		this.zipPassWord.setText(curVal);
		zipPassWord.setEnabled(true);

		node = XTree.findNode("/root_element/mailutil",
				jkmt.xmlEditorPanel.xTree.doc);
		// if(node == null) error
		curVal = node.getTextContent();

		this.mailUtil.setText(curVal);
		mailUtil.setEnabled(true);

	}

	// for the checkbox
	public void itemStateChanged(ItemEvent e) {
		if (e.getSource() == this.sendAlertsCB) {
			boolean selected = this.sendAlertsCB.isSelected();
			String xpathStr = "/root_element/send_alerts";

			Node node = XTree.findNode(xpathStr, jkmt.xmlEditorPanel.xTree.doc);
			if (node == null)
				return;
			String newVal = selected ? "1" : "0";

			XTree.updateNodeContent(node, xpathStr, newVal);
		}

	}

}
