//~--- JDK imports ------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import org.w3c.dom.*;

abstract public class ToolTab extends JPanel implements ActionListener,
		ItemListener {
	// utility method for use with JLabel
	public static String strHtmlBuild(String[] aboutStrLines) {
		String ret = "";

		ret = "<html>";
		for (String s : aboutStrLines)
			ret += "<p>" + s + "</p>";
		ret += "</html>";

		return new String(ret);
	}

	String aboutStrHtml = null;
	public JLabel currentArgs = null;
	public JCheckBox enabledCheckBox = null;
	Jkmt jkmt = Jkmt.getInstance();
	JPanel ltab = null;
	JPanel ltabCent = null;
	JPanel rtab = null;
	JButton runOnce = null;
	JTabbedPane tabPane;
	String toolName = null;

	UpdateServerPanel usp = null;

	public ToolTab(String toolName, String aboutStrHtml) {
		super();
		this.setLayout(new FlowLayout(FlowLayout.LEADING));

		this.toolName = toolName;
		this.aboutStrHtml = aboutStrHtml;
		tabPane = new JTabbedPane();

		this.ltab = new JPanel();
		ltab.setLayout(new BorderLayout());

		this.rtab = new JPanel();
		rtab.setLayout(new FlowLayout(FlowLayout.LEADING));

		usp = new UpdateServerPanel();

		runOnce = new JButton("Run " + toolName + " once");
		runOnce.setEnabled(false);
		runOnce.setActionCommand("runonce");
		runOnce.setMnemonic(KeyEvent.VK_R);
		runOnce.addActionListener(this);
		usp.add(runOnce);
		ltab.add(usp, BorderLayout.NORTH);

		JPanel tmpp = new JPanel();
		tmpp.setLayout(new FlowLayout(FlowLayout.LEADING));
		ltabCent = new JPanel();
		ltabCent.setLayout(new BoxLayout(ltabCent, BoxLayout.Y_AXIS));
		this.enabledCheckBox = new JCheckBox(toolName + " enabled");
		enabledCheckBox.setSelected(false);
		enabledCheckBox.setEnabled(false);
		ltabCent.add(enabledCheckBox);

		this.currentArgs = new JLabel("Command args: ");
		ltabCent.add(currentArgs);

		tmpp.add(ltabCent);
		ltab.add(tmpp, BorderLayout.CENTER);

		rtab.add(new JLabel(aboutStrHtml));

	}

	public ToolTab(String toolName, String[] aboutStrLines) {
		this(toolName, ToolTab.strHtmlBuild(aboutStrLines));
	}

	public void actionPerformed(ActionEvent e) {
		if (e.getActionCommand().equals("runonce")) {
			System.out.println("runonce");

if(usp.updateButton.isEnabled())
{
    String[] stra = ("The configuration has been modified locally.\nIn order for any changes made to take effect the Server must be updated.\nDo you wish to proceed with  Run Once " + this.toolName + " without Updating Server?").split("\n");
//TODO: perhaps make it non-modal..
int rc = JOptionPane.showConfirmDialog(jkmt, ToolTab.strHtmlBuild(stra));

	if(rc == JOptionPane.NO_OPTION)
	{
	    return;
		// will havetoedit Net.java responseparsing to send both herelike this. so not for now.
		// this.usp.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,"updateserver"));

	} 
	else if(rc == JOptionPane.CANCEL_OPTION)
	{
		return; /* canceled,dont execTool */
	}
	//else if YES_OPTION then proceed:
	}

			jkmt.net.sendExecTool(this.toolName);
		}
	}

	public void disableAll() {
		usp.disableAll();
		runOnce.setEnabled(false);
		enabledCheckBox.setEnabled(false);
	}

	public void enableAtConnect() {
		usp.enableAtConnect();
		runOnce.setEnabled(true);

		/* populate fields with the values from DOM */
		Node node = XTree.findNode("/root_element/tool/exec_info[@name=\""
				+ toolName + "\"]/../enabled", jkmt.xmlEditorPanel.xTree.doc);
		if (node == null) {
			// error
			return;
		}
		String curVal = node.getTextContent();
		boolean enabled = true;
		if ("0".equals(curVal))/* anything but 0 its on */
			enabled = false;
		enabledCheckBox.setSelected(enabled);
		enabledCheckBox.setEnabled(true);
		enabledCheckBox.addItemListener(this);// only add here

		this.refreshCmdArgsLabel(); // setthe cmdargs jlabel text
	}

	// subclasses will be adding to ltab and rtab, so need to add to their
	// parent component after that.
	protected void finishGui() {
		tabPane.add(toolName + " Options", ltab);
		tabPane.add("About " + toolName, rtab);
		add(tabPane);
	}

	// for the checkbox
	public void itemStateChanged(ItemEvent e) {
		if (e.getSource() != this.enabledCheckBox)
			return; /* was probably a subclass's ItemListener implementation */

		boolean enabled = enabledCheckBox.isSelected();
		String xpathStr = "/root_element/tool/exec_info[@name=\"" + toolName
				+ "\"]/../enabled";

		Node node = XTree.findNode(xpathStr, jkmt.xmlEditorPanel.xTree.doc);
		if (node == null)
			return;
		String newVal = enabled ? "1" : "0";

		XTree.updateNodeContent(node, xpathStr, newVal);
	}

	// when globla options tab is changed, this gets called for appropriate
	// tooltabs..
	// is invoked in this.enableAtConnect also.
	public void refreshCmdArgsLabel() {
		String xpathStr = "/root_element/tool/exec_info[@name=\""
				+ this.toolName + "\"]/@opts";
		Node node = XTree.findNode(xpathStr, jkmt.xmlEditorPanel.xTree.doc);
		// if(node == null) error
		String curVal = node.getTextContent();

		this.currentArgs.setText("Command args: " + this.toolName + " "
				+ curVal);

	}

}
