#ifndef KMT_COMMON_H
#define KMT_COMMON_H

#include <elf.h>

#include <openssl/md5.h>
#include <openssl/ssl.h>
#include <openssl/err.h>


#ifdef x86_64
        typedef Elf64_Ehdr ElfX_Ehdr;
        typedef Elf64_Phdr ElfX_Phdr;
        typedef Elf64_Shdr ElfX_Shdr;
        typedef Elf64_Addr ElfX_Addr;
        typedef Elf64_Off  ElfX_Off;
        typedef Elf64_Word ElfX_Word;
#else
        typedef Elf32_Ehdr ElfX_Ehdr;
        typedef Elf32_Phdr ElfX_Phdr;
        typedef Elf32_Shdr ElfX_Shdr;
        typedef Elf32_Addr ElfX_Addr;
        typedef Elf32_Off  ElfX_Off;
        typedef Elf32_Word ElfX_Word;

#endif
#ifdef x86_64
typedef unsigned long kmem_off_t;
#else
typedef unsigned long long kmem_off_t;
#endif

int kfd;

void close_snapshot(void);
int open_snapshot(char *path, int perms);
int read_snapshot(unsigned char *mem, unsigned long off, unsigned int bytes);
void closekmem(void);
int openkmem (char *, int);
int readkmem (unsigned char *mem, unsigned long off, int bytes);

int pidfile_make(const char *progname);
pid_t pidfile_read(const char *fpath);

SSL *ssl_accept (int cipher_sock, SSL_CTX * ctx);
int ssl_send (SSL * ssl, void *buf, size_t count);
int ssl_recv (SSL * ssl, void *buf, size_t count);
int ssl_close (SSL * ssl);
SSL_CTX *ssl_init (const char *server_cert_pem, const char *server_privkey_pem);



#endif		/* KMT_COMMON_H */
