/* (C) Innosecc.com 2009 */
/* Author: Ryan O'Neill */

/* Code to get the sys_call_table without System.map */
/* This of course has the potential of being an evil sys_call_table */
/* So It's good to run DPS first to make sure It's not */

/* We use packed attribute so that GCC */
/* does not do any zero padding for word */
/* alignment */

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include "common.h"

struct
{
  unsigned short limit;
  unsigned int base;
} __attribute__ ((packed)) idtr;

struct
{
  unsigned short off1;
  unsigned short sel;
  unsigned char none, flags;
  unsigned short off2;
} __attribute__ ((packed)) idt;

/*
int kfd;

int readkmem (unsigned char *mem, unsigned long off, int bytes)
{
        int c;

        if (lseek64 (kfd, (unsigned long long) off, SEEK_SET) != off)
        {
                printf("[TOOL_FAILURE] (lseek64) %s\n", strerror(errno));
                return -1;
        }

        if ((c = read (kfd, mem, bytes)) != bytes)
        {
                printf("[TOOL_FAILURE] (read %d bytes) %s\n", c, strerror(errno));
                return -1;
        }
	
	return c;
}
*/

unsigned long get_sct(int use_kmt_mem)
{

        FILE *fd;
        unsigned long sct_off;
        unsigned long sct, sysmap_sct = 0;
        unsigned char *p, code[255], buf[255];
        int i, kmt_mem = 0;
        char kmem_path[64];


	/* Get IDT */
        asm ("sidt %0":"=m" (idtr));

        if (use_kmt_mem)
                strcpy(kmem_path, "/dev/kmt_mem");
        else
                strcpy(kmem_path, "/dev/kmem");

	printf("[+] Opening %s\n", kmem_path);

        if ((kfd = open (kmem_path, O_RDONLY)) == -1)
        {
                printf("[TOOL_FAILURE] %s open %s\n", kmem_path, strerror(errno));
                exit(-1);
        }

        /* get int $0x80 */
        if (readkmem ((unsigned char *)&idt, idtr.base + 8 * 0x80, sizeof (idt)) == -1)
        {
                printf("[TOOL_FAILURE] Failed to read from /dev/kmem %s\n", strerror(errno));
                exit(-1);
        }

        /* get system_call() */
        sct_off = (idt.off2 << 16) | idt.off1;

        if (readkmem (code, sct_off, 0x100) == -1)
        {
                printf("[TOOL_FAILURE] Failed to read from /dev/kmem\n", strerror(errno));
                exit(-1);
        }

        /* find the code sequence that calls sys_call_table fp */
        sct = 0;
        for (i = 0; i < 255; i++)
        {
                if (code[i] == 0xff && code[i+1] == 0x14 && code[i+2] == 0x85)
                        sct = code[i+3] + (code[i+4] << 8) + (code[i+5] << 16) + (code[i+6] << 24);
        }
	
	return sct;

}
