#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>

#include "common.h"
int kfd; 

int openkmem(char *kmem_path, int perms)
{
	
        if ((kfd = open(kmem_path, perms)) == -1)
        {
        	printf("TOOL_FAILURE] open failure on %s: %s\n",kmem_path, strerror(errno));
		return -1;
	}
}
  
int readkmem (unsigned char *mem, unsigned long off, int bytes)
{
        int c;

        if (lseek64 (kfd, (kmem_off_t) off, SEEK_SET) != off)
        {
                printf("[TOOL_FAILURE] (lseek64) %s\n", strerror(errno));
                return -1;
        }

        if ((c = read (kfd, mem, bytes)) != bytes)
        {
                printf("[TOOL_FAILURE] (read %d bytes) %s\n", c, strerror(errno));
                return -1;
        }
}

void closekmem(void)
{
	close (kfd);
}

