/* Very commonly used function for getting the virtual address */
/* of a kernel symbol from System.map or /proc/kallsyms */

#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>

unsigned long get_symbol(char *name, char *path)
{
        FILE *fd;
        char symbol_s[255];
        int i;
        unsigned long address, next_symaddr;
        char tmp[255], type, tmp_type;

        if ((fd = fopen(path, "r")) == NULL)
        {
                printf("[TOOL_FAILURE] fopen %s %s\n", path, strerror(errno));
                exit(-1);
        }

        while(!feof(fd))
        {
                bzero((char *)symbol_s, 255);
                fscanf(fd, "%x %c %s", &address, &type, &symbol_s);

                if (strcmp(symbol_s, name) == 0)
                {
                        fscanf(fd, "%x %c %s", &next_symaddr, &tmp_type, &tmp);
                        fclose(fd);
                        return address;
                }
                /* kallsyms isn't a regular file, meaning there is no EOF */
                if (!strcmp(symbol_s, ""))
                        break;
        }
        return 0;
}

