#include "kmond.h"

/* This logs KMT failures to kmtd.log (or char *logfile) */
/* I.E if an Alert fails, or if a file can't be opened */
/* it prints the message it is logging to stderr */
void KMTLog_err(char *fmt, ...)
{
        FILE *fd;
        char time_buf[255];
        time_t clock;
        struct tm *tm;
        char errmsg[4096];
        va_list va;

        va_start (va, fmt);
        vsnprintf (errmsg, sizeof(errmsg), fmt, va);
        va_end (va);
	
	fprintf(stderr, "%s\n", errmsg);
	fflush(stderr);

        time (&clock);
        tm = gmtime (&clock);
        setlocale (LC_TIME, "C");
        strftime (time_buf, sizeof (time_buf), "%A, %B %e, %Y, %H:%M:%S", tm);
		
	if ((fd = fopen("/var/log/kmt/kmond.log", "a")) == NULL)
		return;

        fprintf(fd, "%s %s\n", time_buf, errmsg);

	fflush(fd);
	fclose(fd);
}
