#include "kmtd.h"

int IsElf(char *path)
{
	struct stat st;
        ElfX_Ehdr *ehdr;
        int fd;
	uint8_t *mem;

	if ((fd = open(path, O_RDONLY)) == -1)
		return 0;
	
	if (fstat(fd, &st) < 0)
		return 0;
	
	mem = mmap(NULL, st.st_size, PROT_READ, MAP_PRIVATE, fd, 0);
        if (mem == MAP_FAILED)
		return 0;
	
	ehdr = (ElfX_Ehdr *)mem;

	 if (ehdr->e_ident[0] != 0x7f && strcmp(&ehdr->e_ident[1], "ELF"))
                return 0;

        if (ehdr->e_type != ET_EXEC)
                return 0;
	
#ifdef x86_64
	if (ehdr->e_machine != EM_X86_64)
		return 0;
#else
        if (ehdr->e_machine != EM_386)
                return 0;
#endif
        
        return 1;
}

