
/*
 * KMTD (C) Innosecc.com 2009.
 * The Kernel malware tracker Daemon. This software abides by the KMTD protocol
 * as specified in KMTD-PROTOCOL file.
 * Author of Daemon: Ryan@Innosecc.com
 * Author of Client: Sean@Innosecc.com
 *     
 */

#include "kmtd.h"

/* We should probably put this in one of the config file */
#define TAIL_LOCATION "/bin/tail"

extern struct opts opts;

/* This function kills tail process ID's once finished with them */
/* It will make sure the PID's are within the PGID of kmtd before */
/* killing them; in other words random /bin/tail processes won't be */
/* killed */

int kill_tails(pid_t kmtd_pgid)
{
        FILE *pd;
        char *p, cmd[255], buf[255];
        int pid, i = 0;
        char val[16];
	pid_t tail_pgid;

        snprintf(cmd, sizeof(cmd)-1, "ps xw | grep %s", TAIL_LOCATION);

        if ((pd = popen(cmd, "r")) == NULL)
        {
                KMTLog_err("Fatal error with popen(), must be able to kill /bin/tail processes\n");
                return -1;
        }

        while (fgets(buf, sizeof(buf), pd))
        {
	        if (strstr(buf, TAIL_LOCATION))
                {
                        /* We don't care about the grep itself */
                        if (strstr(buf, "grep"))
                                continue;
			p = buf;
			while (*p != 0x20)
                        	val[i++] = *(p++);
                        val[i] = '\0';
                        pid = atoi(val);

			if (opts.debug)
				printf("/bin/tail pid: %d\n", pid);
			tail_pgid = getpgid(pid);
			if (opts.debug)
				printf("/bin/tail pgid: %d\n", tail_pgid);

			if (tail_pgid == kmtd_pgid)
			{
				if (opts.debug)
					printf("Killing /bin/tail pid %d\n", pid);
				kill(pid, SIGKILL);
			}
		}
	}
		
}

void * tail_dummy(void *data)
{
	struct tail_args args;
	int sfd, lines;
	char logfile[255] = {0};

	memcpy(&args, data, sizeof(struct tail_args));
	
	sfd = args.sfd;
	lines = args.lines;
	
	strncpy(logfile, args.logfile, 255);
	logfile[sizeof(logfile) - 1] = '\0';
	
	if (opts.debug)
		printf("[+] tail_dummy() calling tail_logfile(%d, %s, %d)\n", sfd, logfile, lines);
	
	if (tail_logfile(sfd, logfile, lines) == -1)
		pthread_kill(pthread_self(), SIGINT);
}	 
	
int tail_logfile(int sfd, char *logfile, int lines)
{
	FILE *pd;
	char cmd[strlen(logfile) + 32];
	char buf[512];
	int bytes;

	sprintf(cmd, "%s -n %d -f %s",TAIL_LOCATION, lines, logfile);
	
	if ((pd = popen(cmd, "r")) == NULL)
	{
		KMTLog_err("popen() error: %s", strerror(errno));
		SendMsg(sfd, "-ERR TAIL_CMD_FAILED\n");
		return -1;
	}

	/* a bit of blocking I/O, which is fine */
	while(fgets(buf, sizeof(buf), pd))
	{
		
		bytes = SendMsg(sfd, "+TAIL_OK %s\n", buf);
		if (bytes == PEER_DISCONNECT || bytes == SOCKET_ERR)
		{
			KMTLog_err("send() error: %s\n", strerror(errno));
			return -1;
		}
		
		
	}
	
	return 0;
}

	 
	
	
	
