/* 
 * client.c - this is the command line interface to ktraq. It is perhaps the sloppiest piece of code that I have
 * ever written, and should probably have been done as a script. 
 * <ryan@bitlackeys.com>
 */ 

#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#define BUF_SIZ 100
#define CAT "/bin/cat"
#define MODULE "ktraq.ko"

#define SS "sys_"
#define SYS "sys.map"

void exec_string(char *str, ...)
{
        char string[255];
        va_list va;

        va_start (va, str);
        vsnprintf (string, 255, str, va);
        va_end (va);

        system(string);
}


int main(int argc, char **argv)
{ 
	FILE *pd, *fd, *pf, *sd;
	char buf[BUF_SIZ], map[BUF_SIZ], line[BUF_SIZ], env[BUF_SIZ];
	extern char *optarg;
        char *args[15], sca[32], *p;
	char scavar[64];
	char *search = "ystem";
        int c, *status;
        char funnel = 0, track = 0, clean = 0, remove = 0;
        FILE *sf,*fix, *np;
        char str[255], tmp[255];
        char *ptr;
        int i, count;

	if (argc < 2)
	{
		printf("Ktraq v0.2: Usage: %s [option] <args>\n",argv[0]);
		printf("[Optional] -l (To see available System.map files)\n");
		printf("[Step 1] -f <System.map file> (To assign System map)\n");
		printf("[Step 2] -d (Detect kernel rootkits)\n");
		printf("[Step 3] -r (Remove kernel rootkits)\n"); 
		printf("Note: -d can be used without -r, but -r must be used in conjunction with -d\n");
		exit (0);
	}
        
	while ((c = getopt(argc, argv, "drlf:")) != -1)
	{
		switch(c)
		{
			case 'l':
			        pf = popen("ls /boot", "r");
				while (fgets(line, sizeof(line), pf) != NULL)
					if (strstr(line, search))
						printf("/boot/%s",line); 
		        	exit(-1);
                        break;
			case 'd':
				track = 1;
			break;
			case 'r':
				remove = 1;
			break;
	                case 'f':
				funnel = 1;
			break;
		} 
 
        }      

	if (funnel) {    

	snprintf(map, BUF_SIZ - 1,"%s %s", CAT, argv[2]); 
	
	if ((pd = popen(map, "r")) == NULL)
	{
		perror("popen");
		exit(-1);
	} 
        
	if ((fd = fopen(SYS, "w")) == NULL)
	{
		perror("fopen");
		exit(-1);
	}
        
	while (fgets(buf, sizeof(buf), pd) != NULL)
	{
		if (strstr(buf, SS)) 
			fprintf(fd, "%s", buf);
        }
 
        printf("-Generated file 'sys.map'-\n");
	
        memcpy(env, "SCT=", BUF_SIZ);
	memcpy(sca, "0x", sizeof(sca));
	
        if ((sd = fopen(argv[2], "r")) == NULL)
	{
		perror("fopen");
		exit(-1);
	} 
        
	memset(buf, 0, BUF_SIZ); 
	while(!feof(sd)) 
	{
		fgets(buf, sizeof(buf), sd); 
	        if (strstr(buf, "sys_call_table") && !strstr(buf, "32")) 
		{
			p = strtok(buf, "RrTt");
                        strcat(sca, p);
	                strcat(env, sca);
			putenv(env);
			system("/bin/bash");
		}
		memset(buf, 0, BUF_SIZ);
        } 

	fclose(pd);
	fclose(fd);
        fclose(sd);

	exit (0);
}



if (track) {
	

	if ((sf = fopen("sys.map", "r")) == NULL)
	{
		puts("-No sys.map file found. Run ./ktraq -f first-\n");
		exit (-1);
	}
          
          exec_string("/sbin/insmod %s sct=$SCT", MODULE);
 
          np = popen("$PWD/query sys.map", "r");
          
	  memset(str, 0, 255);
          while(fgets(str, 255, np) != NULL)
          {
                 printf("%s", str);
                 if (strstr(str, "clean.."))
		 clean = 1;
          }

	 pclose(np);
         exec_string ("/sbin/rmmod ktraq");	
	 }

         if (remove) { 
	 	if (track != 1) 
	 	{
	 		printf("Error: Cannot use -r without -d\n");
			exit (-1);
		}  	 
         
	 if (clean == 1)
	 	goto done;
	 	
	 fix = fopen("sys.fix", "r");
         memset(str, 0, 255);
	 fgets(str, 255, fix);

	 memcpy(tmp, str, 255);
         /* yes, very ugly */ 

         ptr = strtok(str, ":"); 
	 ptr = strtok(NULL, ":");
	 for (i = 1; ptr = strtok(NULL, ":") != NULL; i++)
	             ptr = strtok(NULL, ":");
         count = i;
          
	 /* even if kfix isn't installed, if we do a "r' pipe
	  * the user won't see the output if we don't printf it 
	  */
         
	 exec_string("insmod kfix.ko args=%s count=%d sct=$SCT",tmp, count);
	 exec_string("rmmod kfix");

         printf("-[KTRAQ]-The system call table has been restored!\n");
	 printf("-To verify this, please run 'ktraq -d' again.\n");
       }
	 done:
          
	 exit(0);
	 
   }

