/*
 * kfix.c is apart of the Ktraq IDS (c) 2008 Ryan O'Neill <ryan@bitlackeys.com>
 *
 * This code is responsible for restoring the system call table, and vanquishing the rootkit.
 * Whether it be LKM based, or /dev/kmem.
 *
 * http://www.bitlackeys.com
 *
 */ 


#include "ktraq.h" 

#ifndef ULONG_MAX
#define	ULONG_MAX	((unsigned long)(~0L))	
#endif


int kern_atoi (char *string)
{
    int sign;
    int val = 0;

    if ((unsigned long)string == 0L)
    	return 0L;

    if ((sign = (*string == '-') ? -1 : 1) == -1) 
         string++; 
        
    while (*string)
    {
          val = 10 * val + (*string - '0');
          string++;
    }

    return sign * val;
}
						

int k_isspace(char byte)
{
	if (byte == ' ' || byte == '\n' || byte == '\t')
		return 1;
	else
		return 0;
} 
		

unsigned long kern_strtoul (const char *s, const char **ptr, int base)
{
        unsigned long total = 0;
        unsigned digit;
  	const char *start = s;
  	int did_conversion = 0;
  	int overflow = 0;
  	int negate = 0;
        unsigned long maxdiv, maxrem;

        if ((unsigned long)s == 0L)
		return 0L;
        
  	if (s == NULL)
    	{
      	      if (!ptr)
	      *ptr = (char *) start;
     	      return 0L;
    	}

  	while (k_isspace (*s))
    	    s++;
  	if (*s == '+')
    	    s++;
  	else if (*s == '-')
                 s++, negate = 1;
  	if (base == 0 || base == 16)	
    	{
      	    int tmp;
                     
 	    if (*s != '0')
                tmp = 10;
            else if (s[1] == 'X' || s[1] == 'x')
	             tmp = 16, s += 2;	
            else
	    	     tmp = 8;		
            if (base == 0)
	    	base = (int) tmp;
         }

  	maxdiv = ULONG_MAX / base;
  	maxrem = ULONG_MAX % base;

  	while ((digit = *s) != '\0')
    	{
      		if (digit >= '0' && digit < ('0' + base))
		digit -= '0';
      		else if (base > 10)
		{
	  	     if (digit >= 'a' && digit < ('a' + (base - 10)))
	    		 digit = digit - 'a' + 10;
	  	     else if (digit >= 'A' && digit < ('A' + (base - 10)))
	                     digit = digit - 'A' + 10;
	 	     else
	    	     break;
	        }
                else
	        break;
      		did_conversion = 1;
      		if (total > maxdiv || (total == maxdiv && digit > maxrem))
	             overflow = 1;
                total = (total * base) + digit;
     		 s++;
    	}
 	 if (overflow)
   	 {
 	     if (ptr != NULL)
	        *ptr = (char *) s;
      	     return (ULONG_MAX);
         }
 
         if (ptr != NULL)
            *ptr = (char *) ((did_conversion) ? (char *) s : (char *) start);

  return negate ? -total : total;
}


char *
kstrtok_r (char *s1, const char *s2, char **last)
{
  	char *ret;

  	if (s1 == NULL)
            s1 = *last;
        while (*s1 && strchr (s2, *s1))
   	      ++s1;
        if (*s1 == '\0')
            return NULL;
        ret = s1;
        while (*s1 && !strchr (s2, *s1))
              ++s1;
        if (*s1)
            *s1++ = '\0';
        *last = s1;

  return ret;
}

char *args;
int count; 

module_param (args, charp, 0000);
module_param (count, int, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH);

unsigned long sct;
module_param (sct, ulong, 0644);


static int __init
sct_restore (void)
{

	int i = 0;
  	unsigned long **sys_call_table = (unsigned long **)sct;
 
        char *brk, *p;  
	char *tmp;

  	struct scr
  	{
   		unsigned long memaddr;
        	int num;
  	}     scr[256];
 
 
  	p = kstrtok_r (args, ":", &brk);
        scr[0].num = kern_atoi(p);

        p = kstrtok_r (NULL, ":", &brk);
        scr[0].memaddr = kern_strtoul(p, NULL, 16); 
      
        sys_call_table[scr[0].num] = (unsigned long *)scr[0].memaddr;
        
  	for (i = 1; i < count; i++)
  	{ 
              p = kstrtok_r (NULL, ":", &brk);
              scr[i].num = kern_atoi (p);
 
              p = kstrtok_r (NULL, ":", &brk);
              scr[i].memaddr = kern_strtoul(p, NULL, 16); 
                 
              sys_call_table[scr[i].num] = (unsigned long *)scr[i].memaddr;     
  	}
 
  return 0;

}

static void __exit
sct_exit (void)
{
  return 0;
}

module_init (sct_restore);
module_exit (sct_exit);
